set avatarObj 0           ; # avatar object 
set panelObj 0            ; # panel object 
set orgx 0.0              ; # for Rotate drag and release.
set orgy 0.0              ; # for zoom drag and release.

set ColorCount 0

proc DvsMessageDlg {s} { 
    return 
    # for debug
    vsMessageDlg "$s"
}
if {"" == "[info command .top]"} { 
    vstkInit
    source [vsWwwGetFile avscript/colors.tcl]
}
##############################
# get avatar URL.
# 
# out: TergetWorld AvatarUrl
##############################
proc GetAvatarUrl {} { 

    global  vsSuccess vsFailure TargetUrl AvatarUrl

    if { $vsFailure == [vsGetRegistry "ColorRoomArg\\World" ret]} {
        return
    }

    set TargetUrl "$ret"
DvsMessageDlg "$TargetUrl"

    set TargetUrl "[lindex $TargetUrl 0]"

    if { $vsFailure == [vsGetRegistry "ColorRoomArg\\Avatar" ret]} {
        return 
    } 

    set AvatarUrl "$ret"
DvsMessageDlg "$AvatarUrl"
    set AvatarUrl "[lindex $AvatarUrl 0]"
DvsMessageDlg " $TargetUrl $AvatarUrl"
}

proc FakePath {t} {

  for {set i [expr [string length "$t"] -1]} { $i >= 0 } { incr i -1 } {
    if {"[string index $t $i]" == "/"} {
        set b [ string range "$t" 0 $i ]
        set f [ string range "$t" [expr $i +1 ] 999]
        return "$b\s$f"
    }
  }
  return ""
}
##########################
# initialize world
##########################
proc InitWorld {notuse notuse1 notuse2} {

    global panelObj avatarObj vsCSLocal vsRelative vsPick vsTclScript panelObj
    global vsObjAttrComment vsDrag vsRelease AvatarUrl

    if {$avatarObj} {
        return ;
    }

    set person [vsGetPerson]
    # initialize the control panel objects.
    if {!$panelObj} {
        set panelObj [vsAddObjFromFile \
                     $person [vsWwwGetFile "avmodels/panel.wrl"]]

        vsTranslate $panelObj -0.65 1.1 2.0 $vsCSLocal $vsRelative
    }
    #######################################################
    #### todo . read avater file name from prefarence.
    #######################################################
    GetAvatarUrl
    set avatarfile "$AvatarUrl"
    set afile [FakePath "$avatarfile"]

    # initiaize the avatar object.
    set avatarObj [vsAddObjFromFile $person [vsWwwGetFile "$afile"]]
    if {! $avatarObj} {
        vsMessageDlg "error: can't create avatar object."
        return ;
    }

    vsTranslate $avatarObj 0.0 0.78 3.0 $vsCSLocal $vsRelative
    vsRotateAngle $avatarObj 0.0 90.0 0.0 $vsCSLocal $vsRelative
    vsSetObjAttribute $avatarObj $vsObjAttrComment \
	"click to change color, drag to rotate." 
    vsAddEventHandler  $avatarObj $vsPick $vsTclScript "" "ColorProc" ""
    vsAddEventHandler  $avatarObj $vsDrag $vsTclScript "" "drgProc" ""
    vsAddEventHandler  $avatarObj $vsRelease $vsTclScript "" "relProc" ""

    SetAvatarColor $avatarObj

    vsGetObjWRT $avatarObj x y z
    vs3DPosTo2DPos $x $y $z xx yy
    set yy [expr $yy - 180]
    set xx [expr $xx + 80]
    wm geometry .top  "+$xx+$yy"
}

####################################################
# SetAvatarColor
####################################################

proc SetAvatarColor {obj} {

   ################ here is test code.

    global Colors  
    global vsDiffuse TargetUrl AvatarUrl
    
    catch {vsGetRegistry "AvatarColor\\$TargetUrl\\$AvatarUrl" ret } t
DvsMessageDlg "t:$t"
    if {"" != "$t"} {
	return 
    }
    
DvsMessageDlg "ret:$ret"
    set ret [lindex $ret 0]
    unpackColors "$ret"

    if {"" == [info global Colors]} {
	return ;
    }
    foreach d "[array names Colors]" { 
DvsMessageDlg "$d $Colors($d)"
	set part [vsGetObjByName $obj $d -r]
	if {$part} { 
	    eval "vsSetObjAllMaterial $part $vsDiffuse \
		    $Colors($d)"
	}
    }
}
 
    
####################################################
# world_out event 
####################################################
proc OutWorld {notuse notuse1 notuse2} {

    global avatarObj Colors TargetUrl AvatarUrl

    if {$avatarObj} { 
        vsDelObj $avatarObj
        set avatarObj 0
    }
    foreach d {Colors TargetUrl AvatarUrl} {
        if {"" == [info global $d]} { 
            continue
        }
        unset $d
    }
    DvsMessageDlg "out  $avatarObj"
}

##################################################
# get object's part name.
#
# 
# ret : VsObj
# nameret: objrct name
##################################################
proc getObjName {obj nameret} { 
    global vsObjAttrName
    set parent $obj
    vsGetObjAttribute $obj $vsObjAttrName name
    
    while {"" == "$name" } {
        set parent [vsGetObjParent $obj]
        if {! $parent} {
            return ""
        }
        vsGetObjAttribute $parent $vsObjAttrName name
    }
    upvar $nameret rr
    set rr $name
    return $parent
}

##################################################
# pick event handler of Avatar Obj 
##################################################
proc ColorProc {obj ev data} {

    global  Colors  ColorCount vsDiffuse 
    set Partobj [getObjName [vsGetEventObj $ev] name]
    
    if { $Partobj} {
       global SelectedColor
       eval "vsSetObjAllMaterial $Partobj $vsDiffuse \
                 $SelectedColor"
       set Colors($name) "$SelectedColor"
    } 
    wm withdraw .top 
    wm deiconify .top 
    #vsMessageDlg "color proc"
}

############################################
# global Colors  packԂB
############################################
proc packColors {} { 
    global Colors

    if {"" == [info global Colors]} { 
	return ""
    }

    set ret ""
    foreach d "[array name Colors]" {
	set color $Colors($d)
	set c ""
	foreach dd "$color" { 
	    if {"1.0" == $dd} {
		set c "$c+"
	    } {
		set c "$c[string index $dd 2]"
	    }
	}
	if {3 != [string length $c]} { 
	    continue
	}
	lappend ret $d
	lappend ret $c
    }
    return "$ret"
}


#######################################
# [0-9+][0-9+][0-9+] -> ?.X ?.X ?.X
#######################################
proc _unpackColors {str} { 
    set l [string length "$str"]
    if {$l < 3} { 
	return ""
    }
    set ret ""
    for {set i 0} {$i < 3} { incr i} {
	set c [string index "$str" $i]
	if { "$c" == "+" } {   
	    set v 1.0
	} { 
	    set v 0.$c
	}
	lappend ret $v
    }
    return "$ret"
}

########################################
# stř͎^
# 
# parts1 parts2 ... partsN
#
# parts : partname [0-9+][0-9+][0-9+]
#
# [0-9] ́A   0.X 
# +     ́A   1.0  \B
#
# global ColorsɒlԂB
#######################################

proc  unpackColors {str} { 

    global Colors

    if {"" != "[info global Colors]"} {
	unset Colors
    }
    set l [llength "$str"]
    if { $l && [expr $l / 2] } { 
	incr l -1
    }
    for {set i 0} { $i < $l } { incr i } { 
	set part [lindex "$str" $i]
	incr i
	set color [_unpackColors [lindex "$str" $i]]
	if {"" == "$color"} {
	    continue
	}
	set Colors($part) $color
    }
}

##################################################
# ok button handler. 
##################################################
proc okProc {obj ev data} { 
    global Colors  TargetUrl AvatarUrl
    DvsMessageDlg "ok"

    set t  "[packColors]"
    DvsMessageDlg "[packColors]"

    foreach d "[array names Colors]" {
        DvsMessageDlg "$d $Colors($d)"
    }

    vsSetRegistry "AvatarColor\\$TargetUrl\\$AvatarUrl" $t 
    vsBackwardPage
}


##################################################
# cancel button handler. 
##################################################
proc cancelProc {obj ev data} {
    DvsMessageDlg "cancel"
    vsBackwardPage
}

##################################################
# Rotate release handler. 
##################################################
proc relProc {obj ev data} {
    global orgx
    set orgx 0.0
    wm withdraw .top 
    wm deiconify .top 
}

#################################################
# Rotate drag handler.
#################################################
proc drgProc {obj ev data} {
    vsGetEvent2DPoint $ev x y

    global orgx avatarObj vsCSLocal vsRelative

    if {$orgx < $x} {
        set val 10.0
    } {
        set val -10.0
    }

    vsRotateAngle $avatarObj 0.0 $val 0.0 $vsCSLocal $vsRelative
    set orgx $x
    #vsMessageDlg "drg $x $y"
}

#################################################
# zoom release handler. 
#################################################
proc GoBackRel {obj ev d} {
    global orgy
    set orgy 0.0
    wm withdraw .top 
    wm deiconify .top 
}
################################################
# zoom drag handler.
################################################
proc GoBackDrag {obj ev d} {
    vsGetEvent2DPoint $ev x y
    global orgy avatarObj vsCSParent vsRelative

    if {$orgy < $y} {
        set tval 0.1
    } {
        set tval -0.1
    }
    vsTranslate $avatarObj 0.0  0.0  $tval $vsCSParent $vsRelative
    set orgy $y
}
proc Wallpick {obj ev data} { 
    wm withdraw .top 
    wm deiconify .top 
}

