#(c)Copyright 1996 Sony Corporation. All rights reserved.
#*******************************
# Initialize
#*******************************
#----------------------------------------------------
# World Clock
#----------------------------------------------------
set SkyFlg 0
set ClockSky 0

#
# Kinemation Object
#

set Ashika 0
set Kuma 0
set Piero1 0	;# accordion
set Piero2 0	;# ball
set Piero3 0	;# tall
set Tama 0

#
# Kuma 8
#
set Kuma_ang 0
set Kuma_cnt 0
set KumaId 0

set Piero1Cnt 0
set Piero2Cnt 0
set Piero3Cnt 0
set Piero1Id 0
set Piero2Id 0
set Piero3Id 0
set Piero2Dir 0

set ParadeID	0
set ParadeFlg	0
set IllumiNo 0
set IllumiR  1
set IllumiG  1
set IllumiB  1
set IllumiCnt 0

# this 'time' counts up every second.
# one actual second is 1/15 virtual hour.
#   0 = 0:00 (reset)
#  60 = 4:00 (start sunrise)
# 120 = 8:00 (end sunrise)
# 240 = 16:00(start sunset)
# 300 = 20:00(end sunset)
# 360 = 24:00(wind up the counter)
#-----------------------------------------------------------
set currentTime 60	;# 4:00 start sunrise
set EclipseID 0
set EclipseFlg 0
set worldobj 0
set world_rotate 0
set world_ride 0
set light 0
set airship 0
set geton 0
set light 0
set Accordion 0
set Acco1 0
set Acco2 0
#-----------------------------------------------------------
proc vs_H_InitWorld { obj event userdata } {
	global worldobj world_rotate world_ride light wheel exit airship
	global Tama geton light Accordion Acco1 Acco2

	set worldobj [ vsGetObjByName "world" ]	;# InitWorld
	set light [ vsGetObjByName "Light" ]	;# InitWorld
	set airship [ vsGetObjByName "Airship" ];# InitWorld
	set wheel [ vsGetObjByName "ferris.wheel" ]	;# InitWorld
	set exit [ vsGetObjByName "Exit.panel" ]	;# InitWorld
	set Tama [ vsGetObjByName "piero.tama" ]	;# InitWorld
	set geton [ vsGetObjByName "Geton.plate" ]
	set light [ vsGetObjByName "Light" ]
	set Bullet [ vsGetObjByName "Cannon.Bullet" ]
	set Accordion [vsGetObjByName "accordion" ]
	set Acco1 [vsGetObjByName "accordion.ac1" ]
	set Acco2 [vsGetObjByName "accordion.ac2" ]
}

proc vs_H_InitWorldValue { obj event userdata } {
	global vsTrue vsContinue
	global currentTime
	global worldobj world_rotate world_ride

	if [vscpAmIMaster == $vsTrue] {
		# I am Master
		# vsMessageDlg "master"

		# share values
        	vscpSendApplSpecificMsg $obj "ShareValue" $world_rotate

		# vsMessageDlg "share: $value"
        	vscpSendApplSpecificMsg $obj "ShareRide" $world_ride

		ShareClock $obj $event $currentTime
        	vscpSendApplSpecificMsg $obj "ShareClock" $currentTime
	} {
		# I am Slave
		# vsMessageDlg "slave"
		vscpSendApplSpecificMsg $obj "vs_H_InitWorldValue" "$userdata"
	}
	# vsMessageDlg "InitWorldValue"

	return $vsContinue
}

proc ShareValue { obj event userdata } {
	global vsTrue
	global vsContinue vsCSWorld vsCSLocal vsAbsolute vsRelative 
	global worldobj world_rotate world_ride wheel

	# set world valiable
	set world_rotate $userdata

#	vsMessage "rotate: $userdata"
	
	set angle [ expr $userdata * 6.0 ]
	vsObjectRotateAngle $wheel  0.0 0.0 -${angle} $vsCSLocal $vsAbsolute

	# gondola
	for { set i 0 } { $i < 8 } { incr i } {
		set gon [ vsGetObjByName "ferris.wheel.gondola${i}.g${i}" ]
		vsObjectRotateAngle $gon  0.0 0.0 $angle $vsCSLocal $vsAbsolute
	}

	return $vsContinue
}

#----------------------------------------
# set ride
#----------------------------------------
proc ShareRide { obj event userdata } {
	global vsTrue
	global vsContinue vsCSWorld vsCSLocal vsAbsolute vsRelative 
	global worldobj world_rotate world_ride

	# set world valiable
#	set worldobj [ vsGetObjByName "world" ]

#	vsSetVariable $worldobj ride $userdata	
	set world_ride $userdata

	return $vsContinue
}

#----------------------------------------
# set currentTime
#----------------------------------------
proc ShareClock { obj event userdata } {
	global vsContinue currentTime
	global light

	set currentTime $userdata	

#	vsMessageDlg "Time: $currentTime"
	# change light
	if { $currentTime >= 90  && $currentTime < 270 } {
	        vsSwitchObj $light  0
		# vsMessageDlg "light: 0 day"
	} else {
	        vsSwitchObj $light  1
		# vsMessageDlg "light: 1 night"
	}
	return $vsContinue
}


#----------------------------------------
# Solar Eclipse / turn off the light
#----------------------------------------
proc vs_H_Event_PickEclipse { obj event userdata } {
	global vsTrue vsContinue

	if [vscpAmIMaster == $vsTrue] {
		# I am Master
		SetEclipse $obj $event $userdata
		vscpSendApplSpecificMsg $obj "SetEclipse" "$userdata"
		
	} {
		# I am Slave
		vscpSendApplSpecificMsg $obj "vs_H_Event_PickEclipse" "$userdata"
	}
	return $vsContinue
}

proc SetEclipse { obj event userdata } {
	global vsContinue EclipseID EclipseFlg
	global vsTclScript vsPeriodicTask
	global light

	if { $EclipseFlg != 0 } { 
		return $vsContinue
	}
	set EclipseFlg 1

#	set light [ vsGetObjByName "Light" ]
        vsSwitchObj $light  2
	# vsMessageDlg "eclipse"

	# sound on
	vsPlayAmbientSoundByName sound_switch 0

	set EclipseID [ vsAddTimeOutHandler $obj 10000 $vsTclScript \
		"" vs_H_Periodic_ResetEclipse "$userdata" $vsPeriodicTask ]

	return $vsContinue
}
proc vs_H_Periodic_ResetEclipse { obj event userdata } {
	global vsStop EclipseID EclipseFlg
	global currentTime
	global light

	# vsMessageDlg "reset eclipse"
	if { $currentTime >= 90  && $currentTime < 270 } {
	        vsSwitchObj $light  0

	} else {
	        vsSwitchObj $light  1
	}
	vsRemoveTimeOutHandler $obj $EclipseID
	set EclipseFlg 0

	return $vsStop
}

#----------------------------------------------------
# this 'time' counts up every second.
# one actual second is 1/15 virtual hour.
#   0 = 0:00 (reset)
#  60 = 4:00 (start sunrise)
# 120 = 8:00 (end sunrise)
# 240 = 16:00(start sunset)
# 300 = 20:00(end sunset)
# 360 = 24:00(wind up the counter)
#----------------------------------------------------
# World Clock (system time) 
#
proc vs_H_Periodic_WorldClock { obj event userdata } {
	global vsContinue currentTime
	global vsCSLocal vsRelative
	global ClockSky geton vsDiffuse light ParadeFlg

	if { $ClockSky == 0 } {
		# sky : background color
		vs_H_Periodic_ChangeBgColor $obj $event $userdata

		# rotate Geton plate
		vsSetObjAllMaterial $geton $vsDiffuse 1 0 0

		set ClockSky 1
	} else {
		vsSetObjAllMaterial $geton $vsDiffuse 0 1 0

		set ClockSky 0
	}

	# Airship rotation
	if { 2 == [ expr $currentTime & 3 ] } {
		vs_H_PeriodicRotateAirship $obj $event $userdata
	}

	# change light & parade
	if { $currentTime == 90 } {
	        vsSwitchObj $light  0
	} elseif { $currentTime == 270 } {
	        vsSwitchObj $light  1
		# PARADE !!
		vs_H_InitParade $obj $event $userdata
		set ParadeFlg 1
		vs_H_PeriodicParade $obj $event $userdata
	}

	if { $ParadeFlg == 1 } {
		if { $currentTime > 270 && $currentTime < 330 } {
			vs_H_PeriodicParade $obj $event $userdata
		} elseif { $currentTime == 330 } {
			vs_H_EndParade $obj $event $userdata
			set ParadeFlg 0
		}
	}

	# count up
	set currentTime [expr $currentTime + 1]
	if {$currentTime >= 360} {
		set currentTime 0
	}
	if { $currentTime == 0 } {
		vs_H_SyncWorldClock $obj $event $userdata
	}
	return $vsContinue
}


# NOTE: we have to add 'vs_H_Periodic_' prefix for periodic task
#       you must not CHANGE function name!!.

proc vs_H_Periodic_ChangeBgColor { obj event userdata } {
  global vsCameraAttrBackground  vsSuccess
  global vsContinue
  global currentTime SkyFlg

  # parameters
  set sunriseStartTime 60
  set sunriseMidStartTime 70
  set sunriseMidEndTime 70
  set sunriseEndTime 120
  set sunsetStartTime 240
  set sunsetMidStartTime 250
  set sunsetMidEndTime 250
  set sunsetEndTime 300

  set nightColorR 0.1
  set nightColorG 0.1
  set nightColorB 0.35

  set sunriseColorR 0.60
  set sunriseColorG 0.10
  set sunriseColorB 0.08

  set daylightColorR 0.44
  set daylightColorG 0.49
  set daylightColorB 1.0

  set sunsetColorR 0.60
  set sunsetColorG 0.10
  set sunsetColorB 0.08

  # get local variables.
#  set currentTime [vsGetVariable $obj m_currentTime]

  # get the active camera.
  set camera [vsGetActiveCamera]
  if {0 == $camera} {
    vsWarning "vsGetActiveCamera failed"
  }

  # decide bg color

  if {$currentTime < $sunriseStartTime} {
    incr SkyFlg

    # night
    set red $nightColorR
    set green $nightColorG
    set blue $nightColorB

  } elseif {$currentTime < $sunriseMidStartTime} {
    set SkyFlg 0

    # sun rise. (night -> sunrise peak)
    set red   [calcColorElm $currentTime $sunriseStartTime $sunriseMidStartTime \
                            $nightColorR $sunriseColorR]
    set green [calcColorElm $currentTime $sunriseStartTime $sunriseMidStartTime \
                            $nightColorG $sunriseColorG]
    set blue  [calcColorElm $currentTime $sunriseStartTime $sunriseMidStartTime \
                            $nightColorB $sunriseColorB]

  } elseif {$currentTime < $sunriseMidEndTime} {
    incr SkyFlg

    # sunrise peak.
    set red   $sunriseColorR
    set green $sunriseColorG
    set blue  $sunriseColorB

  } elseif {$currentTime < $sunriseEndTime} {
    set SkyFlg 0

    # sun rise. (peak -> daylight)
    set red   [calcColorElm $currentTime $sunriseMidEndTime $sunriseEndTime \
                            $sunriseColorR $daylightColorR]
    set green [calcColorElm $currentTime $sunriseMidEndTime $sunriseEndTime \
                            $sunriseColorG $daylightColorG]
    set blue  [calcColorElm $currentTime $sunriseMidEndTime $sunriseEndTime \
                            $sunriseColorB $daylightColorB]

  } elseif {$currentTime < $sunsetStartTime} {
    incr SkyFlg

    # daylight.
    set red   $daylightColorR
    set green $daylightColorG
    set blue  $daylightColorB

  } elseif {$currentTime < $sunsetMidStartTime} {
    set SkyFlg 0

    # sunset. (daylight -> sunset peak)
    set red   [calcColorElm $currentTime $sunsetStartTime $sunsetMidStartTime \
                            $daylightColorR $sunsetColorR]
    set green [calcColorElm $currentTime $sunsetStartTime $sunsetMidStartTime \
                            $daylightColorG $sunsetColorG]
    set blue  [calcColorElm $currentTime $sunsetStartTime $sunsetMidStartTime \
                            $daylightColorB $sunsetColorB]

  } elseif {$currentTime < $sunsetMidEndTime} {
    incr SkyFlg

    # sunset peak.
    set red   $sunsetColorR
    set green $sunsetColorG
    set blue  $sunsetColorB

  } elseif {$currentTime < $sunsetEndTime} {
    set SkyFlg 0

    # sunset. (peak -> night)
    set red   [calcColorElm $currentTime $sunsetMidEndTime $sunsetEndTime \
                            $sunsetColorR $nightColorR]
    set green [calcColorElm $currentTime $sunsetMidEndTime $sunsetEndTime \
                            $sunsetColorG $nightColorG]
    set blue  [calcColorElm $currentTime $sunsetMidEndTime $sunsetEndTime \
                            $sunsetColorB $nightColorB]

  } else {
    incr SkyFlg

    # night.
    set red   $nightColorR
    set green $nightColorG
    set blue  $nightColorB

  }

  # set bg color
  if { $SkyFlg <= 1 } {
	  set ret [vsSetCameraAttribute $camera \
	             $vsCameraAttrBackground $red $green $blue]
  } else {
	  set SkyFlg 2
  }

  return $vsContinue
}


#
#                         (endColor - startColor) x (time - startTime)
#    color = startColor + --------------------------------------------
#                                     endTime - startTime
#
#            startColor x (endTime - time) + endColor x (time - startTime)
#          = -------------------------------------------------------------
#                               endTime - startTime
#
proc calcColorElm { time startTime endTime startColor endColor } {
  return [expr (($startColor * ($endTime - $time)) \
                  + ($endColor * ($time - $startTime))) \
                  / ($endTime - $startTime) ]
}

#-----------------------------------------------
# PARADE
#
proc vs_H_InitParade { obj event userdata } {
	global vsTclScript vsPeriodicTask vsCSWorld vsAbsolute
	global vsCSLocal vsRelative
	global Ashika Kuma Piero1 Piero2 Piero3 Tama
	global ParadeID vsContinue Accordion

	# set initial position to parade

	vsTranslate $Piero1 15 3.5 0 $vsCSWorld $vsAbsolute
	vsTranslate $Accordion 15 3.5 0 $vsCSWorld $vsAbsolute
	vsTranslate $Piero2 15 3.9 0 $vsCSWorld $vsAbsolute
	vsTranslate $Tama 15 3.0 0 $vsCSWorld $vsAbsolute
	vsTranslate $Piero3 15 4.5 0 $vsCSWorld $vsAbsolute
	vsTranslate $Ashika 15 2.7 0 $vsCSWorld $vsAbsolute
	vsTranslate $Kuma 15 2.7 0 $vsCSWorld $vsAbsolute

	# experimental value (^^;
	vsRotateAngle $Kuma -30.0 0.0 0.0 $vsCSWorld $vsAbsolute

	# set initial rotation
	vsRotateAngle $Piero2 0.0 10.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Tama 0.0 10.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Piero3  0.0 20.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Ashika  0.0 30.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Kuma  0.0 45.0 0.0 $vsCSWorld $vsRelative

#	set ParadeID [ vsAddTimeOutHandler $Piero1 1000 $vsTclScript \
		"" vs_H_PeriodicParade "$userdata" $vsPeriodicTask ]

	# sound on
	vsPlayAmbientSoundByName sound_parade 1

	return $vsContinue
}
proc vs_H_PeriodicParade { obj event userdata } {
	global vsCSWorld vsRelative vsContinue vsCSLocal
	global Ashika Kuma Piero1 Piero2 Piero3 Tama Accordion

	vsRotateAngle $Piero1  0.0 -6.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Accordion  0.0 -6.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Piero2  0.0 -6.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Tama  0.0 -6.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Piero3  0.0 -6.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Ashika  0.0 -6.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Kuma  0.0 -6.0 0.0 $vsCSWorld $vsRelative

	# local rotation
	vsRotateAngle $Tama 15.0 0 0 $vsCSLocal $vsRelative

	# kinemation
	vsKinNextPosture $Piero1
	vsKinNextPosture $Piero2
	vsKinNextPosture $Piero3
	vsKinNextPosture $Ashika
	vsKinNextPosture $Kuma

	return $vsContinue
}
proc vs_H_EndParade { obj event userdata } {
	global Ashika Kuma Piero2 Piero3 Accordion Tama
	global vsCSWorld vsRelative vsContinue vsCSLocal
	
	# reset initial rotation
	vsRotateAngle $Piero2 0.0 -10.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Tama 0.0 -10.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Piero3  0.0 -20.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Ashika  0.0 -30.0 0.0 $vsCSWorld $vsRelative
	vsRotateAngle $Kuma  0.0 -45.0 0.0 $vsCSWorld $vsRelative

	# set initial position
	SetInitPos

	# sound off
	vsStopSoundByName sound_parade

	# reset 
	set Piero2Dir 0
}

proc vs_H_Periodic_Illumi { obj event userdata } {
	global vsDiffuse vsContinue
	global IllumiNo
	global IllumiR IllumiG IllumiB
	global IllumiCnt
	global illumi00 illumi01 illumi02 illumi03 illumi04 illumi05
	global illumi06 illumi07 illumi08 illumi09

	# change color
	set illumi [ vsGetObjByName "flagall.light0$IllumiNo" ]

	vsSetObjAllMaterial $illumi $vsDiffuse $IllumiR $IllumiG $IllumiB

	incr IllumiNo
	if { $IllumiNo > 9 } {
		set IllumiNo 0

		incr IllumiCnt
		if { $IllumiCnt > 3 } {
			set IllumiCnt 0
		}

		# set illumination color
		if { $IllumiCnt == 0 } {
			set IllumiR 0
			set IllumiG 0
			set IllumiB 0	
		} elseif { $IllumiCnt == 1 } {
			set IllumiR 1
			set IllumiG 1
			set IllumiB 1	
		} elseif { $IllumiCnt == 2 } {
			set IllumiR 1
			set IllumiG 0
			set IllumiB 0
		} elseif { $IllumiCnt == 3 } {
			set IllumiR 0.3
			set IllumiG 1
			set IllumiB 0.1
		}

	}

	return $vsContinue
}

proc vs_H_PeriodicRotateAirship { obj event userdata } {
	global airship
	global vsCSWorld vsRelative vsContinue

	vsRotateAngle $airship  0.0 6.0 0.0 $vsCSWorld $vsRelative
	return $vsContinue
}


proc vs_H_InitKinObj { obj ev userdata } {
	global vsTclScript vsPeriodicTask vsCSWorld vsRelative vsPick
	global vsAbsolute
	global Ashika Kuma Piero1 Piero2 Piero3
	global Tama vsPick 

	set boy 0

	# New Kinemation Obj.
	vsKinNew   models/ashikin.wrl Ashika
	vsKinNew   models/kuma3kin.wrl Kuma
	vsKinNew   models/acokin.wrl Piero1
	vsKinNew   models/tama2kin.wrl Piero2
	vsKinNew   models/tallkin.wrl Piero3

	# Piero1
	vsAddEventHandler $Piero1 $vsPick $vsTclScript "" "vs_H_PickPiero1" "data"
	# Piero2
	vsAddEventHandler $Piero2 $vsPick $vsTclScript "" "vs_H_PickPiero2" "data"
	# Piero3
	vsAddEventHandler $Piero3 $vsPick $vsTclScript "" "vs_H_PickPiero3" "data"
	# Kuma
	vsAddEventHandler $Kuma $vsPick $vsTclScript "" "vs_H_PickKuma" "data"

	# set inital position
	SetInitPos
}

proc vs_H_PeriodicKinNextPosture { obj ev userdata } {
	global Ashika Kuma Piero1 Piero2 Piero3
	global vsContinue

	vsKinNextPosture $Piero1
	vsKinNextPosture $Piero2
	vsKinNextPosture $Piero3
	vsKinNextPosture $Ashika
	vsKinNextPosture $Kuma

	return $vsContinue
}

#-------------------------------------------------------------------------
# Kuma
#
proc vs_H_PeriodicKuma { obj ev userdata  } {
	global vsCSWorld vsRelative vsCSLocal vsAbsolute
	global vsContinue vsStop
	global Kuma_cnt Kuma_ang Kuma KumaId

	vsKinNextPosture $Kuma

	if { $Kuma_cnt < 18 } {
		vs_H_PeriodicRotateLeft $Kuma $ev $userdata
		# adjust angle for wheely
		vsRotateAngle $Kuma  -30.0 0.0 0.0 $vsCSLocal $vsRelative


	} elseif { $Kuma_cnt < 36 } {
		vs_H_PeriodicRotateRight $Kuma $ev $userdata
		# adjust angle for wheely
		vsRotateAngle $Kuma  -30.0 0.0 0.0 $vsCSLocal $vsRelative

	} else {
		set Kuma_cnt 0 
		# reset position for safe
		ResetKumaPos

		vsRemoveTimeOutHandler $Kuma $KumaId
		return $vsStop
	}

	incr Kuma_cnt
	return $vsContinue
}

proc vs_H_PeriodicRotateLeft { obj ev userdata  } {
	global vsCSWorld vsRelative vsCSLocal vsAbsolute
	global Kuma_ang Kuma

	vsRotateAngle $Kuma  0.0 $Kuma_ang 0.0 $vsCSWorld $vsAbsolute
	vsTranslate $Kuma 0 0 0.4 $vsCSLocal $vsRelative

	set Kuma_ang [ expr $Kuma_ang - 20.0 ]
}

proc vs_H_PeriodicRotateRight { obj ev userdata  } {
	global vsCSWorld vsRelative vsCSLocal vsAbsolute
	global Kuma_ang Kuma

	vsRotateAngle $Kuma  0.0 $Kuma_ang 0.0 $vsCSWorld $vsAbsolute
	vsTranslate $Kuma 0 0 0.4 $vsCSLocal $vsRelative
	set Kuma_ang [ expr $Kuma_ang + 20.0 ]
}



proc SetInitPos  { } {
	global Ashika Kuma Piero1 Piero2 Piero3 Accordion
	global vsCSWorld vsRelative vsCSLocal vsAbsolute
	global Tama

	# set initial position
	vsTranslate $Piero1 10 3.5 10 $vsCSWorld $vsAbsolute
	vsTranslate $Accordion 10 3.5 10 $vsCSWorld $vsAbsolute
	vsTranslate $Piero2 -10 3.9 5 $vsCSWorld $vsAbsolute
	vsTranslate $Piero3 -3 1.8 -40 $vsCSWorld $vsAbsolute
	vsTranslate $Ashika -60 0.68 34.7 $vsCSWorld $vsAbsolute
	ResetKumaPos
	vsTranslate $Tama -10 3.0 5 $vsCSWorld $vsAbsolute

}
proc ResetKumaPos { } {
	global Kuma
	global vsCSWorld vsAbsolute

	vsTranslate $Kuma -30 0.2 -30 $vsCSWorld $vsAbsolute
}

#*******************************
# Piero Action
#*******************************
#
# accordion pierrot
#
proc vs_H_PickPiero1 { obj event userdata } {
	global Piero1Cnt Piero1Id Piero1 vsTclScript vsPeriodicTask
	global ParadeFlg

	if { $Piero1Cnt == 0 && $ParadeFlg == 0 } {
	    set Piero1Id [vsAddTimeOutHandler $Piero1 500 $vsTclScript "" \
			"vs_H_PeriodicPiero1" "userdata" $vsPeriodicTask]
	}
}

proc vs_H_PeriodicPiero1 { obj event userdata } {
	global vsContinue vsStop Piero1 Piero1Id Piero1Cnt
	global Acco1 Acco2 vsCSLocal vsRelative
	
	if { $Piero1Cnt >= 8 } {
		vsRemoveTimeOutHandler $Piero1 $Piero1Id
		set Piero1Cnt 0

		return $vsStop
	}
	vsKinNextPosture $Piero1

	if { [ expr $Piero1Cnt & 1 ] == 0 } {
		vsTranslate $Acco1 0.03 0.0 0.0 $vsCSLocal $vsRelative
		vsTranslate $Acco2 -0.03 0.0 0.0 $vsCSLocal $vsRelative
	} else {
		vsTranslate $Acco1 -0.03 0.0 0.0 $vsCSLocal $vsRelative
		vsTranslate $Acco2 0.03 0.0 0.0 $vsCSLocal $vsRelative
	}
	incr Piero1Cnt

	return $vsContinue
}
#
# tama pierrot
#
proc vs_H_PickPiero2 { obj event userdata } {
	global Piero2Cnt Piero2Id Piero2 vsTclScript vsPeriodicTask
	global ParadeFlg
	
	if { $Piero2Cnt == 0 && $ParadeFlg == 0 } {
	    set Piero2Id [vsAddTimeOutHandler $Piero2 500 $vsTclScript "" \
			"vs_H_PeriodicPiero2" "userdata" $vsPeriodicTask]
	}
}

proc vs_H_PeriodicPiero2 { obj event userdata } {
	global vsContinue vsStop Piero2 Piero2Id Piero2Cnt Tama Piero2Dir
	global vsCSLocal vsAbsolute vsCSWorld vsRelative
	
	if { $Piero2Cnt >= 8 } {
		vsRemoveTimeOutHandler $Piero2 $Piero2Id
		set Piero2Cnt 0

		if { $Piero2Dir == 0 } {
			set Piero2Dir 1
		} else {
			set Piero2Dir 0
		}

		return $vsStop
	}

	if { $Piero2Dir == 0 } {
		vsTranslate $Tama 0 0 0.1 $vsCSWorld $vsRelative
		vsTranslate $Piero2 0 0 0.1 $vsCSWorld $vsRelative
		vsKinNextPosture $Piero2
		vsRotateAngle $Tama 15.0 0 0 $vsCSLocal $vsRelative

	} else {
		vsTranslate $Tama 0 0 -0.1 $vsCSWorld $vsRelative
		vsTranslate $Piero2 0 0 -0.1 $vsCSWorld $vsRelative
		vsKinPrevPosture $Piero2
		vsRotateAngle $Tama -15.0 0 0 $vsCSLocal $vsRelative
	}

	incr Piero2Cnt

	return $vsContinue
}
#
# taller pierrot
#
proc vs_H_PickPiero3 { obj event userdata } {
	global Piero3Cnt Piero3Id Piero3 vsTclScript vsPeriodicTask
	global ParadeFlg
	
	if { $Piero3Cnt == 0 && $ParadeFlg == 0 } {
	    set Piero3Id [vsAddTimeOutHandler $Piero3 500 $vsTclScript "" \
			"vs_H_PeriodicPiero3" "userdata" $vsPeriodicTask]
	}
}

proc vs_H_PeriodicPiero3 { obj event userdata } {
	global vsContinue vsStop Piero3 Piero3Id Piero3Cnt
	
	if { $Piero3Cnt > 9 } {
		vsRemoveTimeOutHandler $Piero3 $Piero3Id
		set Piero3Cnt 0

		return $vsStop
	}
	vsKinNextPosture $Piero3
	incr Piero3Cnt

	return $vsContinue
}
#
# Kuma 8
#
proc vs_H_PickKuma { obj event userdata } {
	global Kuma_cnt KumaId Kuma vsTclScript vsPeriodicTask
	global ParadeFlg
	
	if { $Kuma_cnt == 0 && $ParadeFlg == 0 } {
	    set KumaId [vsAddTimeOutHandler $Kuma 500 $vsTclScript "" \
			"vs_H_PeriodicKuma" "userdata" $vsPeriodicTask]
	}
}

#----------------------------------------------------------------------
# sync world clock
#
proc vs_H_SyncWorldClock { obj event userdata } {
	global vsTrue vsContinue
	global currentTime
	global worldobj world_rotate world_ride

	if [vscpAmIMaster == $vsTrue] {
		# I am Master
        	vscpSendApplSpecificMsg $obj "ShareValue" $world_rotate

		ShareClock $obj $event $currentTime
        	vscpSendApplSpecificMsg $obj "ShareClock" $currentTime
	}
#	vsMessageDlg "Sync rot: $world_rotate  time: $currentTime"

	return $vsContinue
}

#----------------------------------------------------------------------


